#!/usr/bin/perl -T
BEGIN{
#LIBPATH is where VBS.pl is located
 $LIBPATH="../../Lib";
 unshift(@INC,$LIBPATH);
}
#    Copyright (C) 1996 - Brad Daugherty (1/7/97) 
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#    The full license can be found at: 
#	http://www.pobox.com/~bsd/vbs/license.html
#
#ARGV[0] = Definition file
#ARGV[1] = Input file, leave blank to use STDIN

require "VBS.pl";
if ($#ARGV == -1){
 print "What is the name of the board you want to build? (????.defs) =>";
 chomp($boardname=<STDIN>);
}
else{$boardname=$ARGV[0];}

$boardname=~ s/\.defs$//; #Remove the ".defs" from boardname
$boardname=~/^(\w+)$/;
$boardname=$1;
if(!$boardname || !-e "$LIBPATH/$boardname.defs"){
 die "The boardname is illegal or the definitions file doesn't exists: $!.\n";
}
else{require "$boardname.defs";}

###############Start  Here#####################
###############################################
$grandparent=0;
$parent=0;
$aftnumber=0;
$filein=0;
$last=0;
$lastlast=0;
$setaft=0;
if ($#ARGV == 1){
 $filename=$ARGV[1];
 open(INPUT,"<$filename") || die "Can't open $filename: $!";
 $filein=1;
 while(<INPUT>){
  chomp($_);
  &MassAdd($_);
 }
}
else{
 while(1){
  print "Parent=$parent\nAfter=$aftnumber\nLast=$last\nLastLast=$lastlast\n";
  print "Enter heading, subheading, parent value, after value, or ?\n",
	"Value =>";
  chomp($input=<STDIN>);
  &MassAdd($input);
 }
}
exit(1);

sub MassAdd {
#@_[0]=A string of input
 my($input)=@_[0];
 $input=~s/^\s+//;	#squish initial spaces
 $input=~/(.*)/;		#detaint
 $input=$1;
 if($input=~/^(EXIT|END|QUIT)$/i){
  exit(1);
 }
 elsif($input=~/^#/){return(1);}
 elsif($input=~/^(\?|HELP)$/i){
  print <<END;
A Heading or Subheading can be any text string
A Parent Value is in the format:
    parent=(#|LAST)
	"#" is the number of the parent
		To find the number look at the URL
	"last" means use the last entry as the parent value
An After Value is in the format:
    after=(#|LAST)
	"#" is the number to place entry after 
		To find the number look at the URL
	"last" (default) means use the last entry as the after value 
"? or HELP" will get you this message.
END
  return(1);
 }
 elsif($input=~/^parent=(\d+|LAST)$/i){
  $parent=$1;
  if(uc($parent) eq "LAST"){
   $parent=$last;
   $lastlast=$last;
   $last=0;
   $aftnumber=0;
   $setaft=1;
  }
  elsif($parent == 0){
   $aftnumber=$lastlast;
   $last=0;
   $lastlast=0;
  }
  else{
   $last=0;
   $lastlast=$last;
   $aftnumber=0;
  }
  $setaft=1;
  print "****** Parent set to $parent ******\n";
  return(1);
 }
 elsif($input=~/^after=(\d+|LAST)$/i){
  $aftnumber=$1;
  if(uc($aftnumber) eq "LAST"){
   $aftnumber=$last;
  }
  print "****** After set to $aftnumber ******\n";
  $setaft=1;
  return(1);
 }
 else{$head=$subhead=$input;}
 if(!$setaft){$aftnumber=$last;}
 else{$setaft=0;}	#Reset the flag
#If (sub)head is defined check for duplicates
 (*numlist,*titlelist,*listarray)=&GetListing("top");
 if(&SearchList($input,@titlelist)){
  print "This is a duplicate: $input\n";
  if($filein){die "Can't continue, please re-check your input.";}
  else{return(0);}
 }
 else{ #Add the (sub)heading
  if($parent){
   $arsubhead=1;$arhead=0;
   print "Adding Subheading: $input\n";
  }
  else{
   $arhead=1;$arsubhead=0;
   print "Adding Heading: $input\n";
  }
  $last=$number=&GetLastNumber();
  if( &Add($number) ){
   if($arhead){&MakeChild(0,$number);}
   elsif($arsubhead){
    &MakeChild($parent,$number);
    &PMCount('+',1);
   }
  }
  else{print "The addition of \"$input\" failed!\n";}
  return(1);
 }
}
